<?php defined('SYSPATH') or die('No direct script access.');
 
class Model_Kohana_Account extends Model
{
    public function setHashKey($key)
    {
        $sql = "SELECT `SetHashKey`('$key') AS `Key`;";
        $key = DB::query(Database::SELECT, $sql)->execute();
        return $key->get('Key');
    }
    
    public function getHashKey()
    {
        $sql = "SELECT `GetHashKey`() AS `Key`;";
        $key = DB::query(Database::SELECT, $sql)->execute();
        return $key->get('Key');
    }
    
    public function checkAuth($login, $password) {
        $sql = "SELECT `SignIn`('$login', '$password') AS `ID`;";
        $login = DB::query(Database::SELECT, $sql)->execute();
        return $login->get('ID');
    }
    
    public function ChangeTeacherInfo($id, $lastName, $firstName, $secondName, $degreeID, $departamentID)
    {
        $sql = "SELECT `ChangeTeacherInfo`('$id', '$lastName', '$firstName', '$secondName', '$degreeID', '$departamentID') AS `UserID`;";
        $key = DB::query(Database::SELECT, $sql)->execute();
        return $key->get('UserID');
    }
    
    public function createTeacher($lastName, $firstName, $secondName, $degreeID, $departamentID, $activationCode)
    {
        $sql = "SELECT `CreateTeacher`('$lastName', '$firstName', '$secondName', '$degreeID', '$departamentID', '$activationCode') AS `UserID`;";
        $key = DB::query(Database::SELECT, $sql)->execute();
        return $key->get('UserID');
    }
    
    public function createTeacherByDepName($lastName, $firstName, $secondName, $departamentName, $activationCode)
    {
        $sql = "SELECT `CreateTeacherByDepName`('$lastName', '$firstName', '$secondName', '$departamentName', '$activationCode') AS `UserID`;";
        $key = DB::query(Database::SELECT, $sql)->execute();
        return $key->get('UserID');
    }
    
    public function createStudent($lastName, $firstName, $secondName, $grade, $groupNum, $facultyID, $activationCode)
    {
        $sql = "SELECT `CreateStudent`('$lastName', '$firstName', '$secondName', '$grade', '$groupNum', '$facultyID', '$activationCode') AS `UserID`;";
        $key = DB::query(Database::SELECT, $sql)->execute();
        return $key->get('UserID');
    }   
	
    public function createStudentEx($lastName, $firstName, $secondName, $gradeNum, $groupNum, $degree, $specialization, $facultyID, $activationCode)
    {
        $sql = "SELECT `CreateStudentEx`('$lastName', '$firstName', '$secondName', '$gradeNum', '$groupNum', '$degree', '$specialization', '$facultyID', '$activationCode') AS `UserID`;";
        $key = DB::query(Database::SELECT, $sql)->execute();
        return $key->get('UserID');
    }   

    public function createSubject($name, $abbr, $facultyID)
    {
        $sql = "SELECT `CreateSubject`('$facultyID', '$name', '$abbr') AS `Num`;";
        $response = DB::query(Database::SELECT, $sql)->execute();
        return $response->get('Num');
    }  
    
    public function getPersonalInfo($id)
    {
        $sql = "CALL `GetPersonalInfo`('$id');";
        $query = DB::query(Database::SELECT, $sql)->execute();
        return $query;
    }
        
    public function GetAccountInfo($id)
    {
        $sql = "CALL GetAccountInfo('$id');";
        $query = DB::query(Database::SELECT, $sql)->execute();
        return $query;
    }
    
    public function changeMail($id, $mail)
    {
        $sql = "SELECT `ChangeMail`('$id', '$mail') AS Num;";
        $query = DB::query(Database::SELECT, $sql)->execute();
        return $query->get('Num');
    }   
    
    public function changeLogin($id, $login)
    {
        $sql = "SELECT `ChangeLogin`('$id', '$login') AS Num;";
        $query = DB::query(Database::SELECT, $sql)->execute();
        return $query->get('Num');
    }

    public function changePassword($id, $password)
    {
        $sql = "SELECT `ChangePassword`('$id', '$password') AS Num;";
        $query = DB::query(Database::SELECT, $sql)->execute();
        return $query->get('Num');
    }
    
    public function getAccNumByLogin($login)
    {
        $sql = "SELECT `GetAccCountByLogin`('$login') AS Num;";
        $login = DB::query(Database::SELECT, $sql)->execute();
        return $login->get('Num');
    }
    
    public function getAccNumByMail($email)
    {
        $sql = "SELECT `GetAccCountByMail`('$email') AS Num;";
        $email = DB::query(Database::SELECT, $sql)->execute();
        return $email->get('Num');
    }    
    
    public function isActivationCodeValid($code)
    {
        $sql = "SELECT `GetAccCountByCode`('$code') AS Num;";
        $res = DB::query(Database::SELECT, $sql)->execute();
        foreach ($res as $value) {
            $count = $value['Num'];
        }
        return $count == 1;
    }
    
    public function createRecoveryToken($email, $token)
    {
        $sql = "SELECT `CreateRecoveryToken`('$email', '$token') AS Num;";
        $email = DB::query(Database::SELECT, $sql)->execute();
        return $email->get('Num');
    }
    
    public function getRecoveryInfoByEMail($email)
    {
        $sql = "CALL GetRecoveryInfoByEMail('$email');";
        $query = DB::query(Database::SELECT, $sql)->execute();
        return $query;
    }
    
    public function getRecoveryInfoByToken($token)
    {
        $sql = "CALL GetRecoveryInfoByToken('$token');";
        $query = DB::query(Database::SELECT, $sql)->execute();
        return $query;
    }
    
    public function useRecoveryToken($token)
    {
        $sql = "SELECT `UseRecoveryToken`('$token') AS Num;";
        $email = DB::query(Database::SELECT, $sql)->execute();
        return $email->get('Num');
    }
    
    public function activateAccount($login, $password, $email, $code)
    {
        $sql = "SELECT `ActivateAccount` ('$code', '$login', '$email', '$password') AS `Num`; ";
        $res = DB::query(Database::SELECT, $sql)->execute();
        foreach ($res as $value) {
            $id = $value['Num'];
        }
        return $id;
    }
}